%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% AvoidZigzagDir.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [step]=AvoidZigzagDir(point,step,tune,info)
%
% comput a direction to avoid ziggzaging
%
% for details of input and output structures see lmbopt.m
%


function [step]=AvoidZigzagDir(point,step,tune,info)
step.pI   = step.p(point.I);
gTpold    = point.gI'*step.pI;
betak     = 1/(1+info.ng+info.nf2g)^tune.theta;
lam       = (max(step.p'*point.y,1)+betak*gTpold)/point.omega;
step.pI   = betak*step.pI -lam*point.gI;

clear betak lam gTpold

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   