%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% funf.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute function value at x

function [f] = funf(x,prob)

% [f,~]=funfg(x,A,b); % generic call
cas=prob.cas;
switch cas
    case 1
       A=prob.A; b=prob.b; r=A*x-b; f=r'*r/2;
    case 2 % Chained wood
        n=prob.n; f=0;
        for i=2:2:n-2
            A=x(i-1)^2-x(i);
            B=x(i-1)-1;
            C=x(i+1)^2-x(i+2);
            D=x(i+1)-1;
            U=x(i)+x(i+2)-2;
            V=x(i)-x(i+2);
            f=f+100*A^2+B^2+90*C^2+D^2+10*U^2+0.1*V^2;
        end 
    case 3  % Brent
        n=prob.n; f=0;
        for j=1:n
            if j==1
              FA=3*x(j)*(x(j+1)-2*x(j))+0.25*x(j+1)^2;
            elseif j==n
              FA=3*x(j)*(20-2*x(j)+x(j-1))+ 0.25*(20-x(j-1))^2;
            else
              FA=3*x(j)*(x(j+1)-2*x(j)+x(j-1))+ 0.25*(x(j+1)-x(j-1))^2;
            end
            f=f+FA^2;
        end  
        f=0.5*f;
    case 4 % Variational 1
        n=prob.n; P=1/(n+1); f=0;
        for j=1:n
           if j==1
              f=f+0.25*x(j)^2/P+0.125*x(j+1)^2/P+P*(exp(x(j))-1) ;
           elseif j==n 
              f=f+0.25*x(j)^2/P+0.125*x(j-1)^2/P+P*(exp(x(j))-1);
           else
              f=f+0.125*(x(j+1)-x(j-1))^2/P+P*(exp(x(j))-1) ;
           end   
        end 
end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
