%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% quasiNewtonDir.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point,step]=quasiNewtonDir(point,step)
% comput quasi Newton direction
%
% for details of input and output structures see lmbopt.m

function [point,step]=quasiNewtonDir(point,step)


Lam  = sqrt(sum(point.Y(point.I,:).^2'))./...
     sqrt(sum(point.S(point.I,:).^2'));
Ok   = (isnan(Lam) | Lam==0 | isinf(Lam));
Lam(Ok) = 1;  Lam = Lam(:); 


SS=point.S(point.I,:);
on = ones(size(SS,2),1);

U = point.Y(point.I,:)- Lam(:,on).*SS;


M = (point.Y(point.I,:)'*(point.Y(point.I,:)./Lam(:,on)))-point.H;

warning off
z     = M\(U'*(point.gI./Lam));
warning on
step.pI = (U*z-point.gI)./Lam;

point.Lam=Lam;

clear M U z Lam      

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   