%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% scaleDir.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [step,par]=scaleDir(point,step,par)
% choose components of sensible sign and scale
%
% for details of input and output structures see lmbopt.m
%

function [step,par]=scaleDir(point,step,par)
for i=1:point.n,
  if point.x(i)==0,
    sc=min(1,point.upp(i)-point.low(i)); % width defines a scale
    if point.g(i)<0, step.p(i)=sc;
    else,       step.p(i)=-sc;
    end;
  else
    sc=abs(point.x(i)); % x(i) defines a scale
    if point.x(i)==point.low(i), step.p(i)=sc;
    elseif point.x(i)==point.upp(i), step.p(i)=-sc;
    elseif point.g(i)<0,step.p(i)=sc;
    else, step.p(i)=-sc;
    end;
  end;
end
step.p=step.p(:); step.pI = step.p(point.I); par.CG = 1;

clear sc 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   