%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% searchDir.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point]=searchDir(point,tune,info)
% compute the search direction
%
% for details of input and output structures see lmbopt.m


function [point,step,par]=searchDir(point,step,par,tune,info)

if info.ng==1
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%% call scaleDir %%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    [step,par]=scaleDir(point,step,par);
    step.gTp=point.gI'*step.pI;
    if info.prt>=1, 
        disp('searchDir: pinit has computed by scaleDir.m')
    end
elseif par.nlocal==tune.nwait
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%% call quasiNewtonDir %%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    [point,step]=quasiNewtonDir(point,step);
    step.gTp=point.gI'*step.pI;
    % enforce current activities and angle condition
    par.firstAngle=1;
    [step]=enforceAngle(point,step,par,tune);
    
    if info.prt>=1, 
        disp('searchDir: pinit has computed by quasiNewtonDir.m')
    end
else
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%% call AvoidZigzagDir %%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    [step]=AvoidZigzagDir(point,step,tune,info);
    step.gTp=point.gI'*step.pI;
    
    if info.prt>=1, 
        disp('searchDir: pinit has computed by AvoidZigzagDir.m')
    end
end  

if step.gTp>=0, 
    J = find(step.pI.*point.gI>0); step.pI(J)=-step.pI(J);
    step.gTp=point.gI'*step.pI; 
    
    clear J
end
if abs(step.gTp)<=tune.Deltapg*(abs(step.pI)'*abs(point.gI)),
    step.pI=-point.gI; step.gTp=point.gI'*step.pI; 
end

step.p=zeros(point.n,1);step.p(point.I)=step.pI;

 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
