
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% updateInfo.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point,par]=updateInfo(point,par,tune,info)
% update Deltaf and the best point
%
% for details of input and output structures see lmbopt.m
%
function [point,par]=updateInfo(point,par,tune,info)

% update fbest
if point.fnew<point.fbest, 
    par.nstuck=0; point.fbest=point.fnew;
else % possible cycle
     % but often the gradient still decreases nonmonotonically
     par.nstuck=par.nstuck+1;
end;  

% update f
dec = point.fnew<point.f;
if dec % improvement
    par.monotone=1;
    point.Deltaf=point.f-point.fnew;flagmod = mod(info.ng, tune.mf);
    if (flagmod == 0),point.Df(tune.mf) = point.Deltaf;
    else, point.Df(flagmod) = point.Deltaf;end
    elseif point.fnew==point.f 
    % stalled
    par.monotone=0;
else % no descent
    par.monotone=0;
    point.Deltaf= ...
       max(2*point.Deltaf,tune.Deltam*(abs(point.f)+abs(point.fnew)));
    flagmod = mod(info.ng, tune.mf);
    if (flagmod == 0),point.Df(tune.mf) = point.Deltaf;
    else, point.Df(flagmod) = point.Deltaf;
    end
    clear flagmod 
end;

clear dec

point.f=point.fnew;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
